/*
 * MSP430 LCR meter
 * Free for non-commercial use.
 * 
 * Contact: xyphro@gmail.com
 */
 
#ifndef _DAC_H
#define _DAC_H

#include <stdint.h>
#include <stdbool.h>

#define FREQUENCY_100HZ   0
#define FREQUENCY_1000HZ  1
#define FREQUENCY_10000HZ 2
#define FREQUENCY_1000HZ_CAL 3


/* count of samples for 1 shot (based on 120 kHz sampling rate */
#define SAMPLE_COUNT 1200



/* initialize DAC */
void dac_init(void);

/* start waveform generation */
void dac_start_wave(uint8_t freq);

/* acquire "SAMPLE_COUNT" samples, returns a pointer to start of the adc value array */
int16_t *dac_measure(void);

/* stop waveform generation. Post state: Both lines = common mode voltage */
void dac_stop_wave(void);

void dac_switch_wave(uint8_t freq);


#endif
