/*
 * MSP430 LCR meter
 * Free for non-commercial use.
 * 
 * Contact: xyphro@gmail.com
 */
#ifndef _MEASURE_H
#define _MEASURE_H

#include <stdint.h>
#include <stdbool.h>

#define  MEASURE_SCALINGOK  0
#define  MEASURE_OVERFLOW   1
#define  MEASURE_UNDERFLOW  2
#define  MEASURE_OVERFLOW_AND_UNDERFLOW 3

/**
 * measure
 * \param [in]          pinputsamples
 * \param [out]         over_underflow          0               no adc over/underflow
 *                                              1               adc overflow
 *                                              -1              adc underflow
 */
void measure(const int16_t *pinputsamples, uint8_t freq,                        /* input parameters */
             int16_t *pmean, int16_t *prough_amplitude, double *pangle, double *pamplitude, 
             uint8_t *pover_underflow, double *pamplitude_r, double *pamplitude_i);   /* output parameters */

#endif
