/*
 * MSP430 LCR meter
 * Free for non-commercial use.
 * 
 * Contact: xyphro@gmail.com
 */

#include "io430.h"
#include "uart.h"
#include <intrinsics.h>                                                         /* needed for __dleay_cycles macro */

void uart_init(void)
{
  P8SEL |= (1 << 2);                        // P8.2 = TX
  
  UCA1CTL1 |= UCSWRST;                      // **Put state machine in reset**
  UCA1CTL1 |= UCSSEL_2;                     // SMCLK
  UCA1BRW = 104;                            // 1MHz 115200 (see User's Guide)
  UCA1MCTL |= UCBRS_1 + UCBRF_0;            // Modulation UCBRSx=1, UCBRFx=0
  UCA1CTL1 &= ~UCSWRST;                     // **Initialize USCI state machine**
}


void uart_putchar(char ch)
{
  while (!(UCA1IFG&UCTXIFG));             // USCI_A0 TX buffer ready?
  UCA1TXBUF = ch;                         // TX -> character ch
  if (ch == 0x0a)
  {
    uart_putchar(0x0d);
  }
}

void uart_sendstring(const char *str)
{
  while (*str)
  {
    uart_putchar(*str++);
  }
}
